import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import javax.swing.*;

public class Display extends JPanel {
	private static final long serialVersionUID = 1412195377959438643L;
	BufferedImage img;
	Layer[] layers;
	ImagePanel panel;
	ImageIcon icon;
	private Dimension windowSize;
	Raster imageRaster;
	int height;
	int[][] activityMatrix;
	
	
	public Display(){
		windowSize = new Dimension(500, 300);
		this.setPreferredSize(windowSize);
		this.setVisible(true);
		panel = new ImagePanel(50, 30);
		panel.setPreferredSize(windowSize);
		img=(BufferedImage) panel.getImage();

		layers = new Layer[10];
		
		this.add(panel);

		// Generate the initial activity matix:
		activityMatrix = new int[10][100];
		for(int i=0; i<10; i++) {
			for(int j=0; j<100;j++) {
				activityMatrix[i][j] = RGBToInt(0, 0, 0);
			}
		}

	}


	public void update() {
		int row=-1;
		int width = 50;
		int activity, r, g, b;
		
		updateActivity();
		
		
		for(int i=0;i<activityMatrix.length;i++) {
			for(int j=0;j<activityMatrix[0].length;j++) {
			activity = activityMatrix[i][j];
			if (activity>(255)) activity=(int)255;
			int x = j%width;
			if(x==0) row++;
			int y = row;
			r = 255 - activity;
			g = 255;
			b = 255 - activity;
			int rgb = RGBToInt(r, g, b);
			img.setRGB(x, y, rgb);
			}
			row += 1;
		}
		panel.setImage(img);
		panel.repaint();
	}

	private void updateActivity() {
		for (int i=0; i < layers.length; i++) {
			if (layers[i] != null) {
				int[] tempAct = layers[i].getNeuronActivity();
				for (int j = 0; j < tempAct.length; j++ ) {
					activityMatrix[i][j] = tempAct[j];
				}
			}
		}
	}

	public void setLayer(Layer layer, int layerID) {
		layers[layerID] = layer;
	}
	
	private int RGBToInt(final int r, final int g, final int b) {
		int color = 0;
		color = color | b;
		color = color | g << 8;
		color = color | r << 16;   

		return color;
	}

}