import java.math.BigDecimal;
import java.util.ArrayList;
import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

import com.cyberbotics.webots.controller.GPS;


public class ForceGUI extends JFrame{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private JPanel mainPanel;
	private JPanel topPanel;
	
	private ArrayList<JPanel> musclePanels;
	private ArrayList<MuscleModel> muscleModels;
	
	private GPS gps;
	private JPanel p;
	
	public ForceGUI(){
	    this.setName("Muscle Monitor");
	    setVisible(true);
	    mainPanel = new JPanel();
	    getContentPane().add(mainPanel);
	    mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
	    topPanel = new JPanel();
	    
//	    topPanel.add(plotForces);
	    topPanel.add(new JLabel("                                  Force:           "));
	    topPanel.add(new JLabel("                             Torque:          "));
	    topPanel.add(new JLabel("                          Spikerate1:       "));
	    topPanel.add(new JLabel("                    Spikerate2:          "));
	    topPanel.add(new JLabel("                  Muscle Length:            "));
	    topPanel.add(new JLabel("             Velocity:                "));

	    
	    mainPanel.add(topPanel);
	 
	    pack();
	    musclePanels=new ArrayList<JPanel>();
		muscleModels=new ArrayList<MuscleModel>();
    
	}

	public void addMusclePanel(MuscleModel m){
		JPanel panel = new JPanel();
		panel.add(new JLabel(m.getName()));
		panel.add(new JProgressBar(0, (int)m.getMaxForce()));
		panel.add(new JProgressBar(0, 100));
		panel.add(new JProgressBar(0, 100));
		panel.add(new JProgressBar(0, 100));
		panel.add(new JProgressBar(0, 100));
		panel.add(new JProgressBar(0, 100));


		musclePanels.add(panel);
		muscleModels.add(m);
		mainPanel.add(panel);
		
	}
    public void setGps(GPS gps) {
		this.gps = gps;
		p =new JPanel();
		p.add(new JLabel("Distance to goal: "));
		p.add(new JLabel(gps.getValues()[0]+", "+ gps.getValues()[1]+ ", "+gps.getValues()[2]));
		
		mainPanel.add(p);
		pack();
    }
    
    
    public void updatePanels() {
    	for(int i=0;i<musclePanels.size();i++){
    		JPanel panel= musclePanels.get(i);
    		MuscleModel m = muscleModels.get(i);
    		
    		JProgressBar bar1 = (JProgressBar)panel.getComponent(1);
    		JProgressBar bar2 = (JProgressBar)panel.getComponent(2);
    		JProgressBar bar3 = (JProgressBar)panel.getComponent(3);
    		JProgressBar bar4 = (JProgressBar)panel.getComponent(4);
    		JProgressBar vel = (JProgressBar)panel.getComponent(5);
    		JProgressBar vel2 = (JProgressBar)panel.getComponent(6);

    		bar1.setValue((int) (3*m.getForce()));
    		bar2.setValue((int) (30*m.getTorque()));
    		bar3.setValue((int) (100*m.getSpikerate()));
    		bar4.setValue((int) (100*m.getSpikerate2()));
    		vel.setValue((int) (500*m.getLength()));
    		vel2.setValue((int) (100*m.getVelocity()));

    	}

  	  
    }

	public void setDistance(double d) {
		JLabel l= (JLabel)p.getComponent(1);
  	  	
    	double distance = d;
    	BigDecimal bdX = new BigDecimal(distance);
    	bdX = bdX.setScale(3, BigDecimal.ROUND_HALF_UP);
    	distance = bdX.doubleValue();
    	
    	
    	l.setText(" "+distance);
		
	}
}
