
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JTextField;

import com.jeta.forms.components.panel.FormPanel;


public class GUI extends JFrame{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private int frameWidth = 900;
	private int frameLocation= 785;
	private Settings settings;
	private SettingsReader settingsReader;
	private JProgressBar progressBar;
	private ArrayList<JFrame> windowFrames;
	private SpikingNetwork network;
	private Thread networkThread;
	private boolean networkPaused = false;

	private JTextField timesteps_txt ;
	private JTextField synapseAlfa_txt ;
	private JTextField synapseBetta_txt ;
	private JTextField FPS_txt ;
	private JTextField activityStep_txt ;
	private JTextField activityContrast_txt ;
	private JTextField weightUpdateRatio_txt ;
	private JTextField startUpdateWeights_txt ;
	private JTextField RSNeuronRatio_txt ;
	private JTextField RESNeuronRatio_txt ;
	private JTextField INHNeuronRatio_txt ;
//	JTextField numberOfRuns_txt ;
	private JTextField imageWidth;
	private JTextField imageHeight;

//	JTextField spikeRateLast2_txt;
	private JTextField spikeRateAlfa_txt;
	private JComboBox spikeRateType_cmb;
	
	private JTextField SRWindowL1_txt;
	private JTextField SRWindowL2_txt;
	private JTextField SRWindowInterval_txt;
	private JTextField SRWindowL1P_txt;
	private JTextField SRWindowL2P_txt;
	private JTextField SRWindowIntervalP_txt;
	private JTextField SRWindowL1H_txt;
	private JTextField SRWindowL2H_txt;
	private JTextField SRWindowIntervalH_txt;
	
	private JTextField asyn4_txt;
	private JTextField asyn4_3_txt;
	private JTextField asyn3_txt;
	private JTextField asyn3_1_txt;
	private JTextField asyn3_5_txt;
	private JTextField asyn3_6_txt;
	private JTextField asyn7_4_txt;
	private JTextField asyn8_5_txt;
	private JTextField asyn9_6_txt;
	private JTextField asyn5_3_txt;
	private JTextField asyn6_3_txt;
	
	private JTextField asyn5_4_txt;
	private JTextField asyn6_4_txt;

	private JTextField learningConstant_txt;
	private JTextField forgettingConstant_txt;
	private JTextField STDPLearningConstant_txt;
	
	private JTextField internalDelay_txt;
	private JTextField interLayerDelay_txt;

	private JComboBox settings_cmb;
	private JComboBox topology_cmb;

	private JCheckBox showChart1_chb;
	private JCheckBox showChart2_chb;
	private JCheckBox randomInput_chb;
	
	private JTextField randomBursting_txt;
	private JTextField weightFactor_txt;

	private JButton btn_saveSettings;
	private JButton btn_loadSettings;
	private JButton btn_runNetwork;
	private JButton btn_stopNetwork;
	private JButton btn_displeyFirings;
	private JButton btn_resetWin;
	private JButton btn_printSynapses;
	private JButton btn_saveTopology;

	public String defaultSettingsPath;
	public String defaultTopologyPath;

	private JPanel mainPanel;
	private Display display;
	private Layer[] layers;
	private JPanel displayPanel;
	private MyForceC controller;
	
			//X,Y,Z coordiantes for goal position
	private JTextField goalPosX_txt;
	private JTextField goalPosY_txt;
	private JTextField goalPosZ_txt;
	
//	private JLabel simulationTime;
	private JTextField needA_txt;
	private JTextField needB_txt;
	
	
	private FormPanel settingsPanel;
	
	public GUI(MyForceC controller)    {  
		this.controller=controller;
		settingsReader = new SettingsReader();
		mainPanel = new JPanel();
		displayPanel = new JPanel();
		displayPanel.setPreferredSize(new Dimension(800, 600));
		defaultSettingsPath="Settings/";
		defaultTopologyPath="Topology/";
		settings= new Settings("default");
		windowFrames = new ArrayList<JFrame>();
		settings.setController(controller);
		controller.setTheta(settings.getTimeTheta());
		progressBar = new JProgressBar();
		progressBar.setPreferredSize(new Dimension(frameWidth-50, 20));
		progressBar.setMinimum(0);
		progressBar.setMaximum(settings.getTimesteps());
		progressBar.setStringPainted(true);
		networkThread = new Thread();
		settingsPanel = new FormPanel("ANNGUI.xml");       
		getContentPane().add( mainPanel );        // set the size and location of this frame         
		if(System.getProperty("os.name").contains("Mac OS X")) setSize( 1100, 1000 ); //The panel needs to be larger on Mac OS X systems.
		else setSize(frameWidth,880);
		setLocation( frameLocation, 0 );      
		setVisible( true );    
//		simulationTime = new JLabel("Time: 0"); // To time demanding..
		mainPanel.add(settingsPanel);
//		mainPanel.add(simulationTime);
		mainPanel.add(progressBar);
		mainPanel.add(displayPanel);

		initializeGuiParameters();
		fillSettingsDropDown(""); //fills list of settings
		fillTopologyDropDown(""); //fills list of topologies
		updateSettingsFields();
		createDisplays();
	}    
	
	//CONSTRUCTOR FOR TESTING WITHOUT WEBOTS
	public GUI()    {  
		this.controller=null;
		settingsReader = new SettingsReader();
		mainPanel = new JPanel();
		displayPanel = new JPanel();
		displayPanel.setPreferredSize(new Dimension(800, 600));
		defaultSettingsPath="Settings/";
		defaultTopologyPath="Topology/";
		settings= new Settings("default");
		windowFrames = new ArrayList<JFrame>();
		settings.setController(controller);
		progressBar = new JProgressBar();
		progressBar.setPreferredSize(new Dimension(frameWidth-50, 20));
		progressBar.setMinimum(0);
		progressBar.setMaximum(settings.getTimesteps());
		progressBar.setStringPainted(true);
		networkThread = new Thread();
		settingsPanel = new FormPanel("ANNGUI.xml");       
		getContentPane().add( mainPanel );        // set the size and location of this frame         
		if(System.getProperty("os.name").contains("Mac OS X")) setSize( 1100, 1000 ); //The panel needs to be larger on Mac OS X systems.
		else setSize(frameWidth,870);
		
		setLocation( frameLocation, 0 );      
		setVisible( true );    
//		simulationTime=new JLabel("Time: 0");
		mainPanel.add(settingsPanel);
//		mainPanel.add(simulationTime);
		mainPanel.add(progressBar);
		mainPanel.add(displayPanel);
		
		initializeGuiParameters();
		fillSettingsDropDown(""); //fills list of settings
		fillTopologyDropDown(""); //fills list of topologies
		updateSettingsFields();
		createDisplays();
	}    
	

	@SuppressWarnings("deprecation")
	public void pauseNetwork(){
		if(network==null){
			JOptionPane.showMessageDialog(this, "network not yet created... run simulation first");
		}
		else{
			layers = network.getLayers();
			if(layers==null){
				JOptionPane.showMessageDialog(this, "layers not yet created... run simulation first");
			}else{
				if(networkThread.isAlive() && networkPaused) {
					networkThread.resume();
					networkPaused = false;
				}else if(networkThread.isAlive()) {
					networkThread.suspend();
					networkPaused = true;

				}}
		}
	}

	public void runNetwork(){
		// Reset data from previous runs.
		resetAverageStuff();

		fillSettingParameters();
		if(controller!=null){
			controller.setTheta(settings.getTimeTheta());
			controller.setNeedA(settings.getNeedA());
			controller.setNeedB(settings.getNeedB());
			controller.setNeedABMuscles();
		}
		progressBar.setMaximum(settings.getTimesteps()); //*settings.getNumberOfRuns()

		network = new SpikingNetwork(settings, this, controller);

		layers= network.getLayers();			//??

		networkThread = new Thread(network);
		networkThread.start();

	}

	public void createDisplays(){
		display = new Display();
		displayPanel.add(new JLabel("Neuron activity"));
		displayPanel.add(display);
	}

	public Display getDisplay(){
		return display;
	}

	public void saveSettings(){
		String fileName=null;
		fileName = JOptionPane.showInputDialog("Please enter filename: " ,settings_cmb.getSelectedItem() );

		if(!fileName.endsWith(".txt")){
			fileName+=".txt";
		}

		fillSettingParameters();
		if(fileName!=null){
			try {
				settingsReader.writeSettings(settings, defaultSettingsPath+fileName);
			} catch (IOException e) {
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}		
			fillSettingsDropDown(fileName);
		}
	}


	public void loadSettings(){
		String location = defaultSettingsPath+settings_cmb.getSelectedItem().toString();
		try {
			settings = settingsReader.readSettings(location);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		updateSettingsFields();
	}


	public void fillSettingsDropDown(String selected){
		settings_cmb.removeAllItems();
		int selectedInd=0;

		File dir = new File("Settings");
		String[] children = dir.list(); 
		if (children == null) { 

		} else {
			for (int i=0; i<children.length; i++) { 
				String filename = children[i];
				if(filename.endsWith(".txt")){
					settings_cmb.addItem(filename);
				}
				if(filename.equals(selected)){		//WILL BUG IF THERE ARE OTHER FILETYPES IN FOLDER, BUT IT IS NOOOT!!
					selectedInd=i-1;
				}
			} 
		}
		if(settings_cmb.getItemCount()>0){
			settings_cmb.setSelectedIndex(selectedInd);
		}
	}
	public void saveTopology() throws IOException{
		layers = network.getLayers();
		Synapse[] synapses= network.getSynapses();
		
		if(layers==null || network==null || synapses==null){
			JOptionPane.showMessageDialog(this, "network not yet created... run simulation first");
		}
		else{
			String fileName=null;
			fileName = JOptionPane.showInputDialog("Please enter filename: " ,topology_cmb.getSelectedItem() );

			if(!fileName.endsWith(".dat")){
				fileName+=".dat";
			}
			if(fileName!=null){
				FileOutputStream fos = new FileOutputStream(defaultTopologyPath+fileName);
				ObjectOutputStream oos = new ObjectOutputStream(fos);
				oos.writeObject(layers);
				oos.writeObject(synapses);
				oos.flush();
				oos.close();

				fillTopologyDropDown(fileName);

			}
		}
	}

	public void fillTopologyDropDown(String selected){
		topology_cmb.removeAllItems();
		int selectedInd=0;

		File dir = new File("Topology");

		String[] children = dir.list(); 
		if (children == null) { 

		} else {
			for (int i=0; i<children.length; i++) { 
				String filename = children[i];
				if(filename.endsWith(".dat") || filename.endsWith(".txt")){
					topology_cmb.addItem(filename);
				}
				String filenm= "Topology/"+filename;	//selected will be on the form "Topology/filename.txt"
				if(filenm.equals(selected)){		//WILL BUG IF THERE ARE OTHER FILETYPES IN FOLDER, BUT IT IS NOOOT!!
					selectedInd=i-1;
				}
			} 
		}
		topology_cmb.setSelectedIndex(selectedInd);
	}

	public void resetAverageStuff(){
		Globals.runNumber=0;
		Globals.realNrINHNeuron=0;
		Globals.realNrRESNeuron=0;
		Globals.realNrRSNeuron=0;
		Globals.realNrINPNeuron=0;

		Globals.AvgAllFiringsINH=new ArrayList<int[]>();
		Globals.AvgAllFiringsRES=new ArrayList<int[]>();
		Globals.AvgAllFiringsRS=new ArrayList<int[]>();
		Globals.AvgAllFiringsINP=new ArrayList<int[]>();
	}

	private void closeAllGraphs() {
		while(!windowFrames.isEmpty()) {
			windowFrames.get(0).dispose();
			windowFrames.remove(0);
		}
	}
	
	public void addPanelToMain(JButton p){
		mainPanel.add(p);
	}

	private void fillSettingParameters() {
		settings.setTimesteps(Integer.parseInt(timesteps_txt.getText()));
		settings.setAlfa(Double.parseDouble(synapseAlfa_txt.getText()));
		settings.setBetta(Integer.parseInt(synapseBetta_txt.getText()));
		settings.setDefaultFPS(Integer.parseInt(FPS_txt.getText()));
		settings.setActivityStep(Integer.parseInt(activityStep_txt.getText()));
		settings.setActivityContrast(Integer.parseInt(activityContrast_txt.getText()));
		settings.setWeightUpdateRate(Integer.parseInt(weightUpdateRatio_txt.getText()));
		settings.setStartUpdateWeights(Integer.parseInt(startUpdateWeights_txt.getText()));
//		settings.setLastTwoSpikerateConstant(Double.parseDouble(spikeRateLast2_txt.getText()));
		settings.setSpikerateAlfa(Double.parseDouble(spikeRateAlfa_txt.getText()));
		settings.setSpikerateType(spikeRateType_cmb.getSelectedIndex());
		settings.setSRWindowL1(Integer.parseInt(SRWindowL1_txt.getText()));
		settings.setSRWindowL2(Integer.parseInt(SRWindowL2_txt.getText()));
		settings.setSRWindowInterval(Integer.parseInt(SRWindowInterval_txt.getText()));
		settings.setSRWindowL1P(Integer.parseInt(SRWindowL1P_txt.getText()));
		settings.setSRWindowL2P(Integer.parseInt(SRWindowL2P_txt.getText()));
		settings.setSRWindowIntervalP(Integer.parseInt(SRWindowIntervalP_txt.getText()));
		settings.setSRWindowL1H(Integer.parseInt(SRWindowL1H_txt.getText()));
		settings.setSRWindowL2H(Integer.parseInt(SRWindowL2H_txt.getText()));
		settings.setSRWindowIntervalH(Integer.parseInt(SRWindowIntervalH_txt.getText()));
		settings.setGoalPosX(Double.parseDouble(goalPosX_txt.getText()));
		settings.setGoalPosY(Double.parseDouble(goalPosY_txt.getText()));
		settings.setGoalPosZ(Double.parseDouble(goalPosZ_txt.getText()));
		settings.setNeedA(Double.parseDouble(needA_txt.getText()));
		settings.setNeedB(Integer.parseInt(needB_txt.getText()));
		settings.setAsyn4(Double.parseDouble(asyn4_txt.getText()));
		settings.setAsyn4_3(Double.parseDouble(asyn4_3_txt.getText()));
		settings.setAsyn3(Double.parseDouble(asyn3_txt.getText()));
		settings.setAsyn3_1(Double.parseDouble(asyn3_1_txt.getText()));
		settings.setAsyn3_5(Double.parseDouble(asyn3_5_txt.getText()));
		settings.setAsyn3_6(Double.parseDouble(asyn3_6_txt.getText()));
		settings.setAsyn7_4(Double.parseDouble(asyn7_4_txt.getText()));
		settings.setAsyn8_5(Double.parseDouble(asyn8_5_txt.getText()));
		settings.setAsyn9_6(Double.parseDouble(asyn9_6_txt.getText()));
		settings.setAsyn5_3(Double.parseDouble(asyn5_3_txt.getText()));
		settings.setAsyn6_3(Double.parseDouble(asyn6_3_txt.getText()));
		settings.setAsyn5_4(Double.parseDouble(asyn5_4_txt.getText()));
		settings.setAsyn6_4(Double.parseDouble(asyn6_4_txt.getText()));
		settings.setLearningConstant(Double.parseDouble(learningConstant_txt.getText()));
		settings.setForgettingConstant(Double.parseDouble(forgettingConstant_txt.getText()));
		settings.setSTDPLearningConstant(Double.parseDouble(STDPLearningConstant_txt.getText()));
		settings.setInternalDelay(Integer.parseInt(internalDelay_txt.getText()));
		settings.setInterLayerDelay(Integer.parseInt(interLayerDelay_txt.getText()));
		settings.setTopologyFile(defaultTopologyPath+ (String) topology_cmb.getSelectedItem());
		settings.setShowFiringChart(showChart1_chb.isSelected());
		settings.setShowFiringRateChart(showChart2_chb.isSelected());
		settings.setRandomInput(randomInput_chb.isSelected());
		settings.setRandomBurst(Double.parseDouble(randomBursting_txt.getText()));
		settings.setWeightFactor(Double.parseDouble(weightFactor_txt.getText()));
		String name=settings_cmb.getSelectedItem().toString();
		settings.setName(name.substring(0,name.length()-4));
	}

	private void updateSettingsFields() {
		timesteps_txt.setText(Integer.toString(settings.getTimesteps()));
		synapseAlfa_txt.setText(Double.toString(settings.getAlfa()));
		synapseBetta_txt.setText(""+settings.getBetta());
		FPS_txt.setText(Integer.toString(settings.getDefaultFPS()));
		activityStep_txt.setText(Integer.toString(settings.getActivityStep()));
		activityContrast_txt.setText(Integer.toString(settings.getActivityContrast()));
		weightUpdateRatio_txt.setText(Integer.toString(settings.getWeightUpdateRate()));
		startUpdateWeights_txt.setText(Integer.toString(settings.getStartUpdateWeights()));
		spikeRateAlfa_txt.setText(""+settings.getSpikeRateAlfa());
		spikeRateType_cmb.setSelectedIndex(settings.getSpikeRateType());

		SRWindowL1_txt.setText(""+settings.getSRWindowL1());
		SRWindowL2_txt.setText(""+settings.getSRWindowL2());
		SRWindowInterval_txt.setText(""+settings.getSRWindowInterval());
		SRWindowL1P_txt.setText(""+settings.getSRWindowL1P());
		SRWindowL2P_txt.setText(""+settings.getSRWindowL2P());
		SRWindowIntervalP_txt.setText(""+settings.getSRWindowIntervalP());
		SRWindowL1H_txt.setText(""+settings.getSRWindowL1H());
		SRWindowL2H_txt.setText(""+settings.getSRWindowL2H());
		SRWindowIntervalH_txt.setText(""+settings.getSRWindowIntervalH());
		goalPosX_txt.setText(""+settings.getGoalPosX());
		goalPosY_txt.setText(""+settings.getGoalPosY());
		goalPosZ_txt.setText(""+settings.getGoalPosZ());
		needA_txt.setText(""+settings.getNeedA());
		needB_txt.setText(""+settings.getNeedB());
		asyn4_txt.setText(""+settings.getAsyn4());
		asyn4_3_txt.setText(""+settings.getAsyn4_3());
		asyn3_txt.setText(""+settings.getAsyn3());
		asyn3_1_txt.setText(""+settings.getAsyn3_1());
		asyn3_5_txt.setText(""+settings.getAsyn3_5());
		asyn3_6_txt.setText(""+settings.getAsyn3_6());
		asyn7_4_txt.setText(""+settings.getAsyn7_4());
		asyn8_5_txt.setText(""+settings.getAsyn8_5());
		asyn9_6_txt.setText(""+settings.getAsyn9_6());
		asyn5_3_txt.setText(""+settings.getAsyn5_3());
		asyn6_3_txt.setText(""+settings.getAsyn6_3());
		asyn5_4_txt.setText(""+settings.getAsyn5_4());
		asyn6_4_txt.setText(""+settings.getAsyn6_4());
		learningConstant_txt.setText(""+settings.getLearningConstant());
		forgettingConstant_txt.setText(""+settings.getForgettingConstant());
		STDPLearningConstant_txt.setText(""+settings.getSTDPLearningConstant());
		internalDelay_txt.setText(""+settings.getInternalDelay());
		interLayerDelay_txt.setText(""+settings.getInterLayerDelay());
		topology_cmb.setSelectedItem(settings.getTopologyFile());
		showChart1_chb.setSelected(settings.isShowFiringChart());
		showChart2_chb.setSelected(settings.isShowFiringRateChart());
		randomInput_chb.setSelected(settings.getRandomInput());
		randomBursting_txt.setText(""+settings.getRandomBursting());
		weightFactor_txt.setText(""+settings.getWeightFactor());
		fillTopologyDropDown(settings.getTopologyFile());
	}

	public void printSynapses() {
		// PRE NEURON   -------- Type , WEIGHT --------> POST NEURON
		if(network==null){
			JOptionPane.showMessageDialog(this, "network not yet created... run simulation first");
		}
		else{
			layers = network.getLayers();
			if(layers==null){
				JOptionPane.showMessageDialog(this, "layers not yet created... run simulation first");
			}else{
				for(int i= 0; i< layers.length;i++){
					if(layers[i]!= null){
						System.out.println(layers[i].name);
						for(int j=0; j<layers[i].getNodesInLayer().length; j++){
							for(int k=0; k<layers[i].getNodesInLayer()[j].getPostSynapses().size();k++){
								Synapse s=layers[i].getNodesInLayer()[j].getPostSynapses().get(k);
								
								System.out.println(s.preNode.name +" ------- " + s.getType()+" "+ s.getCurrentWeight() +" ------>  " + s.postNode.name +", Asyn: "+s.getAsyn()+ ", Delay: "+ s.getDelay());
							}
						}
					}
				}
			}
		}
	}
	
	public JProgressBar getProgressBar() {
		return progressBar;
	}

	public void setProgressBar(JProgressBar progressBar) {
		this.progressBar = progressBar;
	}

	public ArrayList<JFrame> getWindowFrames() {
		return windowFrames;
	}

	public void setWindowFrames(ArrayList<JFrame> windowFrames) {
		this.windowFrames = windowFrames;
	}
	
	public static void main( String[] args )    {       
		GUI frame = new GUI();       
		frame.addWindowListener( new WindowAdapter()  { 	    
			public void windowClosing( WindowEvent evt ) 	    { 	       
				System.exit(0); 	    
			} 	 
		});   
	} 
	
	public void setSimulationTime(String time) {
		this.setTitle("Time: "+time);
	}
	
	public void initializeGuiParameters(){
		timesteps_txt =settingsPanel.getTextField("timesteps");
		synapseAlfa_txt = settingsPanel.getTextField("synAlfa") ;
		synapseBetta_txt = settingsPanel.getTextField("synBetta") ;
		FPS_txt = settingsPanel.getTextField("fps");
		activityStep_txt =settingsPanel.getTextField("activityStep");
		activityContrast_txt =settingsPanel.getTextField("activityContrast");
		weightUpdateRatio_txt = settingsPanel.getTextField("weightUpdateRatio") ;
		startUpdateWeights_txt = settingsPanel.getTextField("startUpdateWeights") ;
		spikeRateAlfa_txt = settingsPanel.getTextField("spikeRateAlfa") ;
		spikeRateType_cmb = settingsPanel.getComboBox("spikeRateType") ;
		SRWindowL1_txt = settingsPanel.getTextField("windowL1S");
		SRWindowL2_txt = settingsPanel.getTextField("windowL2S");
		SRWindowInterval_txt = settingsPanel.getTextField("windowIntervalS");
		SRWindowL1P_txt = settingsPanel.getTextField("windowL1P");
		SRWindowL2P_txt = settingsPanel.getTextField("windowL2P");
		SRWindowIntervalP_txt = settingsPanel.getTextField("windowIntervalP");
		SRWindowL1H_txt = settingsPanel.getTextField("windowL1H");
		SRWindowL2H_txt = settingsPanel.getTextField("windowL2H");
		SRWindowIntervalH_txt = settingsPanel.getTextField("windowIntervalH");
		goalPosX_txt = settingsPanel.getTextField("goalPosX");
		goalPosY_txt = settingsPanel.getTextField("goalPosY");
		goalPosZ_txt = settingsPanel.getTextField("goalPosZ");
		needA_txt = settingsPanel.getTextField("needA");
		needB_txt = settingsPanel.getTextField("needB");
		asyn4_txt = settingsPanel.getTextField("asyn4");
		asyn4_3_txt = settingsPanel.getTextField("asyn4_3");
		asyn3_txt= settingsPanel.getTextField("asyn3");
		asyn3_1_txt= settingsPanel.getTextField("asyn3_1");
		asyn3_5_txt= settingsPanel.getTextField("asyn3_5");
		asyn3_6_txt= settingsPanel.getTextField("asyn3_6");
		asyn7_4_txt= settingsPanel.getTextField("asyn7_4");
		asyn8_5_txt= settingsPanel.getTextField("asyn8_5");
		asyn9_6_txt= settingsPanel.getTextField("asyn9_6");
		asyn5_3_txt= settingsPanel.getTextField("asyn5_3");
		asyn6_3_txt= settingsPanel.getTextField("asyn6_3");
		asyn5_4_txt= settingsPanel.getTextField("asyn5_4");
		asyn6_4_txt= settingsPanel.getTextField("asyn6_4");
		learningConstant_txt = settingsPanel.getTextField("learningConstant");
		forgettingConstant_txt = settingsPanel.getTextField("forgettingConstant");
		STDPLearningConstant_txt = settingsPanel.getTextField("STDPLC");
		internalDelay_txt = settingsPanel.getTextField("internalDelay");
		interLayerDelay_txt = settingsPanel.getTextField("interLayerDelay");
		settings_cmb = settingsPanel.getComboBox("settings_cmb");
		topology_cmb = settingsPanel.getComboBox("topology_cmb");
		showChart1_chb=settingsPanel.getCheckBox("showChart1");
		showChart2_chb=settingsPanel.getCheckBox("showChart2");
		randomInput_chb= settingsPanel.getCheckBox("randomInput");
		randomBursting_txt= settingsPanel.getTextField("randomBurst");
		weightFactor_txt= settingsPanel.getTextField("weightFactor");
		btn_saveSettings= (JButton) settingsPanel.getButton("saveSettings");
		btn_loadSettings= (JButton) settingsPanel.getButton("loadSettings");
		btn_runNetwork= (JButton) settingsPanel.getButton("runNetwork");
		btn_stopNetwork= (JButton) settingsPanel.getButton("stopNetwork");
		btn_displeyFirings= (JButton) settingsPanel.getButton("pauseNetwork");
		btn_resetWin= (JButton) settingsPanel.getButton("resetWin");
		btn_printSynapses = (JButton) settingsPanel.getButton("printSynapses");
		btn_saveTopology= (JButton) settingsPanel.getButton("saveTopology");
		btn_displeyFirings.setText("Show Firing Graph");
		btn_saveSettings.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				saveSettings();
			}
		});
		btn_loadSettings.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				loadSettings();
			}
		});
		btn_runNetwork.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				if(!networkThread.isAlive()) 
					runNetwork();
			}
		});
		btn_stopNetwork.addActionListener(new ActionListener() {

			@SuppressWarnings("deprecation")
			@Override
			public void actionPerformed(ActionEvent e) {
				if(networkThread.isAlive()) {
					networkThread.stop();
				}
			}
		});

		btn_displeyFirings.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				network.displayFireings(true);
			}
		});
		btn_resetWin.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				closeAllGraphs();
			}
		});
		btn_saveTopology.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					saveTopology();
				} catch (IOException e1) {
					e1.printStackTrace();
				}
			}
		});
		btn_printSynapses.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(network!=null){
					pauseNetwork();
					printSynapses();
					pauseNetwork();
				}
			}
		});
	}
}

