
public class HumeSynapse extends Synapse{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	//Plotting stuff ------------------------------
	private int startTime= 0;
	
	//Select wich neurons to plot
	String preNodeS ="Neuron 6.0";
	String postNodeS = "Neuron 4.0";
//	String preNodeS = "Neuron 4.1";	
//	String postNodeS = "Neuron 4.3";

	private double[] synWeight;
	private double[] synTrace ;
	private double[] synPreSpi ;
	private double[] synPostSpi;
	private double[] synDeltaPostSR ;
	private double[] currentTime ;

	private boolean notShown =false;
	private int counterPlot=0;

	private String synTypePlot;
	// --------------------------------------------
	private boolean updateWeight=true;
	
	//Event stuff
	private int lenghtOfEvent; 
	private int lastEventCounterPost=0;
	private double previousDropPre;
	private double minChange;
	private int lastEventCounterPre;
	private boolean useEvents;
	private double previousIncPost=0;
	private double previousDropPost=0;
	private int lastEventPre=-1;
	private int lastEventPost=0;

	public HumeSynapse(Neuron preNode, Neuron postNode, int synType, double Asyn, Settings z,double initWeight) {
		super(preNode, postNode, synType, Asyn, z, initWeight);

		if(preNode.name.equals(preNodeS) && postNode.name.equals(postNodeS)){
			synWeight = new double[durationOfPlot];
			synTrace = new double[durationOfPlot];
			synPreSpi = new double[durationOfPlot];
			synPostSpi = new double[durationOfPlot];
			synDeltaPostSR = new double[durationOfPlot];
			currentTime = new double[durationOfPlot];
		}

		prevTracePostSpikeRate = 0;

		lenghtOfEvent= 2000/z.getWeightUpdateRate();
		minChange=z.getMinChangeEvent();
		useEvents=z.getUseEvents();

		if(synapseTypeInt==1){	
			synapseType = "H+";		//exitatory	
		}else if(synapseTypeInt==-1){	
			synapseType = "H-";		//inhibitory
		}else if(synapseTypeInt==0){
			synapseType = "H";		//can be both 
		}else{
			System.err.println("Unknown synapsetype");
		}
		synTypePlot = "Hume";
	}

	public void updateWeight() {
		double deltaPreSpikeRate=0;
		double deltaPostSpikeRate=0;
		double deltaW=0;
		double tracePreSpikeRate=0;

		if(z.getSpikeRateType()==3){//3=SPLIT_Window, 
			prevSpikeRate = preNode.getOldSpikeRateWindowH();
			currentSpikeRate = preNode.getCurrentSpikeRateWindowH();

			prevPostNeuronSpikerate = postNode.getOldRealSpikeRateWindowH();//
			currentPostNeuronSpikerate = postNode.getCurrentRealSpikeRateWindowH();//postNode.getSpikerate(0, false);

			deltaPreSpikeRate=  (currentSpikeRate-prevSpikeRate);	//z.getSpikeRateAlfaNow()*
			deltaPostSpikeRate =(currentPostNeuronSpikerate-prevPostNeuronSpikerate);	//z.getSpikeRateAlfaPrev()* 

			//			for plotting
			currentSpikeRate=preNode.getCurrentRealSpikeRateWindowH(); 
			if(SpikingNetwork.currentTime>z.getStartUpdateWeights()){
				deltaW= learningConstant* (-Math.max(deltaPreSpikeRate, 0)) * deltaPostSpikeRate;
			}else{
				deltaW=0;
			}
		}else{
			// Setting the previous spikerate, and updating the current one.
			prevSpikeRate = currentSpikeRate;
			currentSpikeRate = preNode.getSpikerate(delay);
			deltaPreNeuronSpikeRate= (currentSpikeRate-prevSpikeRate)/z.getWeightUpdateRate();

			prevPostNeuronSpikerate = currentPostNeuronSpikerate;
			currentPostNeuronSpikerate = postNode.getSpikerate(0);
			deltaPostNeuronSpikeRate = (currentPostNeuronSpikerate-prevPostNeuronSpikerate)/z.getWeightUpdateRate();
			
			// HUME learning rule.
			deltaPreSpikeRate = Math.pow(deltaPreNeuronSpikeRate, betta); 		// delta X
			deltaPostSpikeRate = Math.pow(deltaPostNeuronSpikeRate, betta); 	// delta Y

// 			NOT IN USE
//			if(useEvents){
//				if(deltaPostSpikeRate>minChange && deltaPostSpikeRate>previousIncPost){
//					previousIncPost=deltaPostSpikeRate;
//					previousDropPost=0;
//					lastEventPost=SpikingNetwork.currentTime;
//					lastEventCounterPost= lenghtOfEvent;
//				}else if(deltaPostSpikeRate<-minChange && deltaPostSpikeRate<previousDropPost){
//					previousDropPost=deltaPostSpikeRate;
//					previousIncPost=0;
//					lastEventPost=SpikingNetwork.currentTime;
//					lastEventCounterPost= lenghtOfEvent;
//				}else if(lastEventCounterPost<1){
//					lastEventPost=-1;
//					previousIncPost=0;
//					previousDropPost=0;
//				}
//				if(deltaPreSpikeRate>minChange && deltaPreSpikeRate>previousDropPre){//lastEventCounter<1){
//					previousDropPre=deltaPreSpikeRate;
//					lastEventPre=SpikingNetwork.currentTime;
//					lastEventCounterPre = lenghtOfEvent;
//				}
//				lastEventCounterPost--;
//				lastEventCounterPre--;
//				if(lastEventCounterPre<1){
//					previousDropPre=0;
//					lastEventPre=-1;
//				}
//				if(lastEventPost>lastEventPre && lastEventPre!=-1){	
//					updateWeight=true;
//					lastEventCounterPre++;
//				}else {
//					updateWeight=false;
//				}
//			}

			
			tracePreSpikeRate = prevTracePreSpikeRate;			 	
			deltaW =  learningConstant *(-Math.max(tracePreSpikeRate, 0)) * (deltaPostSpikeRate + currentWeight*z.getForgettingConstant()); 
			// If pre fires and nothing happens at post during the trace the weight is drawn a little towards 0
			// If pre fires and post fire during the trace the weight is increased/decreased much

			if(z.getStartUpdateWeights()>SpikingNetwork.currentTime || !updateWeight){
				deltaW=0;	//wont update the weight in the start phase.. 
			}
			
			prevTracePreSpikeRate = alfa * prevTracePreSpikeRate + (1-alfa)* deltaPreSpikeRate;	
		}

		currentWeight += deltaW;

		if(synapseTypeInt==1){	
			if(currentWeight<0) currentWeight = 0;		//exitatory	cannot have negative weight	
		}else if(synapseTypeInt==-1){	
			if(currentWeight>0) currentWeight = 0;		//inhibitory cannot have positive weight	
		}else if(synapseTypeInt==0){
			//can be both negative and positive
		}else{
			System.err.println("Unknown synapsetype");
		}


		
		//PLOTTING 
		if(preNode.name.equals(preNodeS) && postNode.name.equals(postNodeS)){
			if(counterPlot<synWeight.length && SpikingNetwork.currentTime>startTime ){
				synWeight[counterPlot]= currentWeight;
				synPreSpi[counterPlot]= currentSpikeRate;
				synPostSpi[counterPlot]= currentPostNeuronSpikerate;
				synDeltaPostSR[counterPlot] = deltaPostSpikeRate;
				currentTime[counterPlot] = SpikingNetwork.currentTime;
				if(z.getSpikeRateType()==Globals.SPLIT_WINDOW){
					synTrace[counterPlot]= deltaPreSpikeRate;
				}else{
					synTrace[counterPlot]= tracePreSpikeRate;
				}
				notShown=true;
				counterPlot++;
			}else if(notShown){
				notShown =false;
				if(z.getSpikeRateType()==Globals.SPLIT_WINDOW){
					showGraph(currentTime,synWeight,synDeltaPostSR,"deltaPostSpikeRate",synPreSpi,synPostSpi,synTrace,"deltaPreSpikeRate" , preNodeS, postNodeS,synTypePlot);
				}else{
					showGraph(currentTime,synWeight,synTrace,"tracePreNode",synPreSpi,synPostSpi, synDeltaPostSR,"deltaPostSpikeRate", preNodeS, postNodeS,synTypePlot);
				}
			}
		}
	}

}
