
import java.io.Serializable;
import java.util.ArrayList;


public class Layer implements Serializable{
	private static final long serialVersionUID = 1L;
	protected Neuron nodeList[];
	protected String name;
	protected int numberOfNodesX;
	protected int numberOfNodesY;
	protected LayerType type;
	protected Display display;
	protected int ONE_TO_ONE=1;
	protected Settings z;
	//plotting stuff
	private ArrayList<int[]> allRsFireings;
	private ArrayList<int[]> allInFireings;
	private ArrayList<int[]> allResFireings;
	protected double initActivationLvl;
	protected int numberOfNeurons;
	protected int numberOfInhibitoryNeurons;
	protected int numberOfThreads;
	protected int realNumberOf_INH_Neurons;
	protected int realNumberOf_RS_Neurons;
	protected int realNumberOf_RES_Neurons;
	protected int layerId;

	public Layer(String name, int layerId, Settings z) {
		this.name = name;
		this.layerId=layerId;
		this.z = z;
		allRsFireings=new ArrayList<int[]>();
		allInFireings=new ArrayList<int[]>();
		allResFireings=new ArrayList<int[]>();
	}

	public int getNumberOfNeurons() {
		return nodeList.length;
	}

	public void addNeurons(Neuron[] neurons) {
		nodeList = neurons;
	}

	public void updateNodes() {
		for(int i=0;i<nodeList.length;i++) {
			nodeList[i].checkFire();
		}
	}

	public String getLayerName(){
		return name;
	}

	public Neuron[] getNodesInLayer(){
		return nodeList;
	}

	public void addFiredToPlot(Neuron n) {
//COMMENTED OUT TO SAVE MEMORY
//		if(n instanceof SensoryNeuron){
//			allInFireings.add(new int[]{n.getId(),SpikingNetwork.currentTime});
//			Globals.AvgAllFiringsINH.add(new int[]{n.getId(),SpikingNetwork.currentTime});
//
//		} else if(n instanceof RESNeuron){
//			allResFireings.add(new int[]{n.getId(),SpikingNetwork.currentTime});
//			Globals.AvgAllFiringsRES.add(new int[]{n.getId(),SpikingNetwork.currentTime});
//
//		} else if(n instanceof RSNeuron){
//			allRsFireings.add(new int[]{n.getId(),SpikingNetwork.currentTime});
//			Globals.AvgAllFiringsRS.add(new int[]{n.getId(),SpikingNetwork.currentTime});
//		} else {
//			
//		}
	}

	public ArrayList<int[]> getAllRsFirings() {
		return allRsFireings;
	}
	public ArrayList<int[]> getAllInFirings() {
		return allInFireings;
	}
	public ArrayList<int[]> getAllResFirings() {
		return allResFireings;
	}

	public int[] getNeuronActivity() {
		int[] neuronActivity = new int[nodeList.length*2];
		int indexCounter=0;
		for(int i=0; i<nodeList.length; i++) {
			neuronActivity[indexCounter] = (int) (nodeList[i].getSpikerate(0) * z.getActivityContrast());
			indexCounter+=2;
		}
		return neuronActivity;
	}

	public int getLayerId() {
		return layerId;
	}
}
