import java.awt.BasicStroke;
import java.awt.Color;
import java.util.ArrayList;

import javax.swing.JFrame;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.xy.DefaultXYDataset;
import org.jfree.ui.RectangleEdge;
import org.jfree.util.ShapeUtilities;

import com.cyberbotics.webots.controller.GPS;
import com.cyberbotics.webots.controller.Robot;
import com.cyberbotics.webots.controller.Servo;



public class MyForceC extends Robot {


	public static int controllerTime;
	private int timeStep=64;
	Servo F_L_Leg_1; //Front Left Leg z rotation
	Servo F_L_Leg_2;
	Servo F_R_Leg_1;
	Servo F_R_Leg_2;

	double F_L_Leg_1_FORCE=0;
	double F_L_Leg_2_FORCE=0;
//	double F_R_Leg_1_FORCE=0;
//	double F_R_Leg_2_FORCE=0;
	MuscleModel muscle_fl_1_1;
	MuscleModel muscle_fl_1_2; 
	MuscleModel muscle_fl_2_1;
	MuscleModel muscle_fl_2_2;
//	MuscleModel muscle_fr_1_1;
//	MuscleModel muscle_fr_1_2;
//	MuscleModel muscle_fr_2_1;
//	MuscleModel muscle_fr_2_2;
	MuscleModel[] allMuscles;
	ForceGUI forceGUI;
	private double maxPos_fl_1;
	private double minPos_fl_1;
	private double maxPos_fl_2;
	private double minPos_fl_2;
//	private double maxPos_fr_1;
//	private double minPos_fr_1;
//	private double maxPos_fr_2;
//	private double minPos_fr_2;
	private ArrayList<Double> force11;
	private ArrayList<Double> force12;
//	private ArrayList<Double> force21;
//	private ArrayList<Double> force22;
	private boolean plotForces=false;
	private double plotTime=0;
	private int plotCount=0;
	private ArrayList<Double> posPlot11;
	private ArrayList<Double> posPlot12;
//	private ArrayList<Double> posPlot21;
//	private ArrayList<Double> posPlot22;
	private ArrayList<Double> spikeRate11;
	private ArrayList<Double> spikeRate12;
	private SensoryNeuron needXDistanceNeuron;
	private SensoryNeuron needYDistanceNeuron;
	private SensoryNeuron needZDistanceNeuron;
	private SensoryNeuron[] needDistanceNeurons;

	private double[] goalPos;
	private double[] currentPos;
	private double[] prevPos;
	private double[] timeNeed;
	private GPS gps;
	private double[] needPos;
	private double[] startDistance;
	private double startDistance1;
	private double distanceNeed;
	private double getUpNeed;
	private Settings settings;//set from GUI
	private double theta;
	private double needA;
	private int needB;

	public MyForceC() {
		super();
		settings= null; 
		theta = 0; 
		currentPos= new double[3];
		timeNeed= new double[3];
		needPos = new double[2];
		startDistance = new double[3];
		needDistanceNeurons = new SensoryNeuron[3];
		distanceNeed=0;
		getUpNeed=0;
		keyboardEnable(10);
		forceGUI=new ForceGUI();
		force11 = new ArrayList<Double>();
		force12 = new ArrayList<Double>();
//		force21 = new ArrayList<Double>();
//		force22 = new ArrayList<Double>();
		posPlot11= new ArrayList<Double>();
		posPlot12= new ArrayList<Double>();
//		posPlot21= new ArrayList<Double>();
//		posPlot22= new ArrayList<Double>();
		spikeRate11= new ArrayList<Double>();
		spikeRate12= new ArrayList<Double>();
		gps = getGPS("gps");
		gps.enable(timeStep);
		F_L_Leg_1=getServo("servo_1_2");
		F_L_Leg_2=getServo("servo_1_1");
		F_R_Leg_1=getServo("servo_2_2");
		F_R_Leg_2=getServo("servo_2_1");
		F_L_Leg_1.enablePosition(timeStep);
		F_L_Leg_2.enablePosition(timeStep);
		F_R_Leg_1.enablePosition(timeStep);
		F_R_Leg_2.enablePosition(timeStep);
		maxPos_fl_1=1;
		minPos_fl_1=-1;
		maxPos_fl_2= 0.6;
		minPos_fl_2=-0.6;
//		maxPos_fr_1= 0.4;
//		minPos_fr_1= -0.4;
//		maxPos_fr_2= 0.6;
//		minPos_fr_2= -0.6;
		double maxForce = 50;
		muscle_fl_1_1 = new MuscleModel("Muscle L_UP_  _", F_L_Leg_1, 	this, minPos_fl_1, maxPos_fl_1,  1, 0.1, maxForce);
		muscle_fl_1_2 = new MuscleModel("Muscle L_DOWN", F_L_Leg_1, 	this, minPos_fl_1, maxPos_fl_1, -1, 0.1, maxForce);	
		muscle_fl_2_1 = new MuscleModel("Muscle L_BACK ", F_L_Leg_2, 	this, minPos_fl_2, maxPos_fl_2,  1, 0.1, maxForce);
		muscle_fl_2_2 = new MuscleModel("Muscle L_FORW", F_L_Leg_2, 	this, minPos_fl_2, maxPos_fl_2, -1, 0.1, maxForce);
//		muscle_fr_1_1 = new MuscleModel("Muscle fr.1.1", F_R_Leg_1, 	this, minPos_fr_1, maxPos_fr_1,  1, 0.1, maxForce);
//		muscle_fr_1_2 = new MuscleModel("Muscle fr.1.2", F_R_Leg_1, 	this, minPos_fr_1, maxPos_fr_1, -1, 0.1, maxForce);
//		muscle_fr_2_1 = new MuscleModel("Muscle fr.2.1", F_R_Leg_2, 	this, minPos_fr_2, maxPos_fr_2,  1, 0.1, maxForce);
//		muscle_fr_2_2 = new MuscleModel("Muscle fr.2.2", F_R_Leg_2, 	this, minPos_fr_2, maxPos_fr_2, -1, 0.1, maxForce);
		allMuscles= new MuscleModel[4];
		allMuscles[0]=muscle_fl_1_1;
		allMuscles[1]=muscle_fl_1_2;
		allMuscles[2]=muscle_fl_2_1;
		allMuscles[3]=muscle_fl_2_2;
//		allMuscles[4]=muscle_fr_1_1;
//		allMuscles[5]=muscle_fr_1_2;
//		allMuscles[6]=muscle_fr_2_1;
//		allMuscles[7]=muscle_fr_2_2;
		forceGUI.addMusclePanel(muscle_fl_1_1);
		forceGUI.addMusclePanel(muscle_fl_1_2);
		forceGUI.addMusclePanel(muscle_fl_2_1);
		forceGUI.addMusclePanel(muscle_fl_2_2);
//		forceGUI.addMusclePanel(muscle_fr_1_1);
//		forceGUI.addMusclePanel(muscle_fr_1_2);
//		forceGUI.addMusclePanel(muscle_fr_2_1);
//		forceGUI.addMusclePanel(muscle_fr_2_2);
		forceGUI.setGps(gps);
	}

	public void run() {
		int newKey;
		int i = 0;
		//main loop
		do {	
			newKey=keyboardGetKey();
			while(newKey!=0 ){
				switch (newKey){
				case 'M':
					muscle_fl_1_1.toggleManualControl();
					muscle_fl_1_2.toggleManualControl();
					muscle_fl_2_1.toggleManualControl();
					muscle_fl_2_2.toggleManualControl();
//					muscle_fr_1_1.toggleManualControl();
//					muscle_fr_1_2.toggleManualControl();
//					muscle_fr_2_1.toggleManualControl();
//					muscle_fr_2_2.toggleManualControl();
					break;
					//FRONT LEFT LEG =============================================
				case 'W':
					muscle_fl_1_1.updateSpikerate(); //ARM UP	
					break;
				case 'A':
					muscle_fl_1_2.updateSpikerate(); //ARM DOWN 
					break;
				case 'S':
					muscle_fl_2_1.updateSpikerate(); //ARM BACKWARD
					break;
				case 'Q':
					muscle_fl_2_2.updateSpikerate(); //ARM FORWARD
					break;
					// END FORNT LEFT --------------------------------------------	
					//FRONT RIGHT LEG =============================================
//				case 'D':
//					muscle_fr_1_1.updateSpikerate(); //ARM DOWN
//					//					F_R_Leg_1_FORCE+=forceIncDec;					 
//					break;
//				case 'R':
//					muscle_fr_1_2.updateSpikerate(); //LIFT ARM
//					//					F_R_Leg_2_FORCE+=forceIncDec;
//					break;
//				case 'E':
//					muscle_fr_2_1.updateSpikerate(); //ARM FORWARD
//					//					F_R_Leg_1_FORCE-=forceIncDec;		
//					break;
//				case 'F':
//					muscle_fr_2_2.updateSpikerate(); //ARM BACK
//					//					F_R_Leg_2_FORCE-=forceIncDec;
//					break;
					// END FORNT RIGHT --------------------------------------------		

				case 'P':
					plotForces=true;
					System.out.println(i++);
					break;
				case 'O':	//Start storing forces and spikerate
					storeValuesForPlot(force11, F_L_Leg_1_FORCE);
					storeValuesForPlot(force12, F_L_Leg_2_FORCE);
					storeValuesForPlot(posPlot11, F_L_Leg_1.getPosition());
					storeValuesForPlot(posPlot12, F_L_Leg_2.getPosition());
					storeValuesForPlot(spikeRate11, muscle_fl_1_1.getSpikerate());
					storeValuesForPlot(spikeRate12, muscle_fl_1_2.getSpikerate());
					break;
				default:
					break;
				}
				newKey=keyboardGetKey();
			}
			muscle_fl_1_1.update();
			muscle_fl_1_2.update();
			muscle_fl_2_1.update();
			muscle_fl_2_2.update();
//			muscle_fr_1_1.update();
//			muscle_fr_1_2.update();
//			muscle_fr_2_1.update();
//			muscle_fr_2_2.update();
			
			if(needXDistanceNeuron!=null){
				updateNeeds();
			}
			
			F_L_Leg_1_FORCE = muscle_fl_1_1.getTorque() - muscle_fl_1_2.getTorque();	
			F_L_Leg_2_FORCE = muscle_fl_2_1.getTorque() - muscle_fl_2_2.getTorque();
//			F_R_Leg_1_FORCE = muscle_fr_1_1.getTorque() - muscle_fr_1_2.getTorque();
//			F_R_Leg_2_FORCE = muscle_fr_2_1.getTorque() - muscle_fr_2_2.getTorque();
			//			printForces();
			forceGUI.updatePanels();

			//COMMENT out if no graph of forces
			//			storeValuesForPlot(force11, F_L_Leg_1_FORCE);
			//			storeValuesForPlot(force12, F_L_Leg_2_FORCE);
			//			storeValuesForPlot(force21, F_R_Leg_1_FORCE);
			//			storeValuesForPlot(force22, F_R_Leg_2_FORCE);
			//			storeValuesForPlot(posPlot11, F_L_Leg_1.getPosition());
			//			storeValuesForPlot(posPlot12, F_L_Leg_2.getPosition());
			//			storeValuesForPlot(posPlot21, F_R_Leg_1.getPosition());
			//			storeValuesForPlot(posPlot22, F_R_Leg_2.getPosition());
			//			storeValuesForPlot(spikeRate11, muscle_fl_1_1.getSpikerate());
			//			storeValuesForPlot(spikeRate12, muscle_fl_1_2.getSpikerate());

			//			if(F_L_Leg_1_FORCE > 0){
			//				F_L_Leg_1.setMotorForce(F_L_Leg_1_FORCE);
			//				F_L_Leg_1.setPosition(maxPos_fl_1);
			//			}else{			
			//				F_L_Leg_1.setMotorForce(- F_L_Leg_1_FORCE);
			//				F_L_Leg_1.setPosition(minPos_fl_1);
			//			}
			//			if(F_L_Leg_2_FORCE > 0){
			//				F_L_Leg_2.setMotorForce(F_L_Leg_2_FORCE);
			//				F_L_Leg_2.setPosition(maxPos_fl_2);
			//			}else{
			//				F_L_Leg_2.setMotorForce(- F_L_Leg_2_FORCE);
			//				F_L_Leg_2.setPosition(minPos_fl_2);
			//			}
			//			if(F_R_Leg_1_FORCE > 0){
			//				F_R_Leg_1.setMotorForce(F_R_Leg_1_FORCE);
			//				F_R_Leg_1.setPosition(maxPos_fr_1);
			//			}else{
			//				F_R_Leg_1.setMotorForce(- F_R_Leg_1_FORCE);
			//				F_R_Leg_1.setPosition(minPos_fr_1);
			//			}
			//			if(F_R_Leg_2_FORCE > 0){
			//				F_R_Leg_2.setMotorForce(F_R_Leg_2_FORCE);
			//				F_R_Leg_2.setPosition(maxPos_fr_2);
			//			}else{
			//				F_R_Leg_2.setMotorForce(- F_R_Leg_2_FORCE);
			//				F_R_Leg_2.setPosition(minPos_fr_2);
			//			}

			if(plotForces){
				plotTime=getTime();
				if(plotCount<5){
					displayGraphF();
					plotCount++;
				}
				plotForces=false;
			}

			F_L_Leg_1.setForce(F_L_Leg_1_FORCE);
			F_L_Leg_2.setForce(F_L_Leg_2_FORCE);
			F_R_Leg_1.setForce(-F_L_Leg_1_FORCE);//Syncronize the legs to make it simpler in start
			F_R_Leg_2.setForce(-F_L_Leg_2_FORCE);//Syncronize the legs 
			//				F_R_Leg_1.setForce(F_R_Leg_1_FORCE);
			//				F_R_Leg_2.setForce(F_R_Leg_2_FORCE); 

			controllerTime++;
		} while(step(timeStep)!=-1);
	}

	public void printForces(){
		System.out.println(F_L_Leg_1.getName()+ " FORCE: "+ F_L_Leg_1_FORCE);
		System.out.println(F_L_Leg_2.getName()+ " FORCE: "+ F_L_Leg_2_FORCE);
//		System.out.println(F_R_Leg_1.getName()+ " FORCE: "+ F_R_Leg_1_FORCE);
//		System.out.println(F_R_Leg_2.getName()+ " FORCE: "+ F_R_Leg_2_FORCE);
	}

	public void storeValuesForPlot(ArrayList<Double> list, double value){
		list.add(value);
	}

	public MuscleModel[] getMuscleModels(){
		return allMuscles;
	}

	public void setNeedNeurons(SensoryNeuron needXDistance, SensoryNeuron needYDistance) {
		this.needXDistanceNeuron=needXDistance;
		this.needYDistanceNeuron=needYDistance;
		needDistanceNeurons[0]=needXDistanceNeuron;	//put them in a array to access them by index
		needDistanceNeurons[1]=needYDistanceNeuron;
	}
	private void updateNeeds() {
		prevPos=currentPos;
		currentPos = gps.getValues();
		double x=currentPos[0];
		double y=currentPos[1];
		double z=currentPos[2];

		if(goalPos!=null){
			double distanceXZ= Math.sqrt(Math.pow(goalPos[0]-x, 2)+ Math.pow(goalPos[2]-z, 2))/(startDistance1); //multiply start distance by two to be able to get a better distribution ax^b total distance to goal //starting at x=0 z=0
			double distanceY= (goalPos[1]-y)/((goalPos[1]-startDistance[1]));
			distanceNeed= needA*Math.pow(distanceXZ, needB)+0.5*distanceXZ+0.2;
			getUpNeed = needA*0*Math.pow(distanceY, needB)+0.5*distanceXZ;
			forceGUI.setDistance(distanceXZ*startDistance1);
		}
		needDistanceNeurons[0].setSensoryValue(distanceNeed);
		needDistanceNeurons[1].setSensoryValue(getUpNeed);
	}

	public void displayGraphF(){
		double[] f11=new double[force11.size()];
		double[] f12=new double[force12.size()];
//		double[] f21=new double[force21.size()];
//		double[] f22=new double[force22.size()];
		double[] ms = new double[force11.size()];
		double[] position11= new double[force11.size()];
		double[] position12= new double[force11.size()];
		double[] position21= new double[force11.size()];
		double[] position22= new double[force11.size()];
		double[] spikeR11= new double[force11.size()];
		double[] spikeR12= new double[force11.size()];

		for(int i= 0; i< force11.size();i++){
			f11[i]=force11.get(i);
			f12[i]=force12.get(i);
//			f21[i]= force21.get(i); 
//			f22[i]= force22.get(i); 
			ms[i]=i;
			position11[i]= posPlot11.get(i);
			position12[i]= posPlot12.get(i);
//			position21[i]= posPlot21.get(i);
//			position22[i]= posPlot22.get(i);
			spikeR11[i]= 10*spikeRate11.get(i);
			spikeR12[i]= -10*spikeRate12.get(i);
		}
		DefaultXYDataset dataForce = new DefaultXYDataset();
		XYLineAndShapeRenderer rendForce=new XYLineAndShapeRenderer(true, false);
		
		dataForce.addSeries("F Left Up/Down",new double[][]{ms,f11});
		rendForce.setSeriesPaint(dataForce.getSeriesCount()-1, Color.GREEN);
		rendForce.setSeriesStroke(dataForce.getSeriesCount()-1, new BasicStroke(1.5f));

		dataForce.addSeries("F Left Back/Forward",new double[][]{ms,f12});
		rendForce.setSeriesPaint(dataForce.getSeriesCount()-1, Color.BLUE);
		rendForce.setSeriesStroke(dataForce.getSeriesCount()-1, new BasicStroke(1.5f));

//		dataForce.addSeries("F Right Up/Down",new double[][]{ms,f21});
//		rendForce.setSeriesPaint(dataForce.getSeriesCount()-1, Color.RED);
//		rendForce.setSeriesStroke(dataForce.getSeriesCount()-1, new BasicStroke(1.5f));

//		dataForce.addSeries("F Right Forward/Back",new double[][]{ms,f22});
//		rendForce.setSeriesPaint(dataForce.getSeriesCount()-1, Color.GRAY);
//		rendForce.setSeriesStroke(dataForce.getSeriesCount()-1, new BasicStroke(1.5f));

		//SpikeRate plot
		dataForce.addSeries("SpikeRate11",new double[][]{ms,spikeR11});
		rendForce.setSeriesPaint(dataForce.getSeriesCount()-1, Color.CYAN);
		rendForce.setSeriesStroke(dataForce.getSeriesCount()-1, new BasicStroke(1.5f));

		dataForce.addSeries("SpikeRate12",new double[][]{ms,spikeR12});
		rendForce.setSeriesPaint(dataForce.getSeriesCount()-1, Color.CYAN);
		rendForce.setSeriesStroke(dataForce.getSeriesCount()-1, new BasicStroke(1.5f));
		
		JFreeChart forceChart = ChartFactory.createXYLineChart(
				"Forces ","Time ms","Torque",
				dataForce,PlotOrientation.VERTICAL,true, true, false);
		forceChart.getPlot().setBackgroundPaint(Color.WHITE);
		forceChart.setBackgroundPaint(Color.WHITE);


		rendForce.setSeriesShape(0, ShapeUtilities.createDiamond(1));
		rendForce.setSeriesShape(1, ShapeUtilities.createDiamond(1));
		rendForce.setSeriesShape(2, ShapeUtilities.createDiamond(1));
		rendForce.setSeriesShape(3, ShapeUtilities.createDiamond(1));

		forceChart.getXYPlot().setRenderer(rendForce);

		forceChart.getXYPlot().setDomainGridlinesVisible(true);  
		forceChart.getXYPlot().setRangeGridlinesVisible(true);  
		forceChart.getXYPlot().setRangeGridlinePaint(Color.black);  
		forceChart.getXYPlot().setDomainGridlinePaint(Color.black);
		forceChart.getLegend().setPosition(RectangleEdge.RIGHT);

		JFrame forceframe = new JFrame("Forces");
		forceframe.setContentPane(new ChartPanel(forceChart));
		forceframe.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		forceframe.setLocation(772, 0);
		forceframe.pack();
		forceframe.setVisible(true);

		DefaultXYDataset dataPos = new DefaultXYDataset();
		XYLineAndShapeRenderer rendPos=new XYLineAndShapeRenderer(true, false);

		dataPos.addSeries("Pos 11",new double[][]{ms,position11});
		rendPos.setSeriesPaint(dataPos.getSeriesCount()-1, Color.GREEN);
		rendPos.setSeriesStroke(dataPos.getSeriesCount()-1, new BasicStroke(
				1.5f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
				1.0f, new float[] {2.0f, 6.0f}, 0.0f
		)
		);
		dataPos.addSeries("Pos 12",new double[][]{ms,position12});
		rendPos.setSeriesPaint(dataPos.getSeriesCount()-1, Color.BLUE);
		rendPos.setSeriesStroke(dataPos.getSeriesCount()-1, new BasicStroke(
				1.5f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
				1.0f, new float[] {2.0f, 6.0f}, 0.0f
		)
		);
		dataPos.addSeries("Pos 22",new double[][]{ms,position22});
		rendPos.setSeriesPaint(dataPos.getSeriesCount()-1, Color.GRAY);
		rendPos.setSeriesStroke(dataPos.getSeriesCount()-1, new BasicStroke(
				1.5f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
				1.0f, new float[] {2.0f, 6.0f}, 0.0f
		)
		);
		dataPos.addSeries("Pos 21",new double[][]{ms,position21});
		rendPos.setSeriesPaint(dataPos.getSeriesCount()-1, Color.RED);
		rendPos.setSeriesStroke(dataPos.getSeriesCount()-1, new BasicStroke(
				1.5f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
				1.0f, new float[] {2.0f, 6.0f}, 0.0f
		)
		);

		JFreeChart posChart = ChartFactory.createXYLineChart(
				"Position ","Time ms","Radians",
				dataPos,PlotOrientation.VERTICAL,true, true, false);
		posChart.getPlot().setBackgroundPaint(Color.WHITE);//new Color(0xBFEFFF));
		posChart.setBackgroundPaint(Color.WHITE);
		posChart.getXYPlot().setRenderer(rendPos);
		posChart.getXYPlot().setDomainGridlinesVisible(true);  
		posChart.getXYPlot().setRangeGridlinesVisible(true);  
		posChart.getXYPlot().setRangeGridlinePaint(Color.black);  
		posChart.getXYPlot().setDomainGridlinePaint(Color.black);
		posChart.getLegend().setPosition(RectangleEdge.RIGHT);

		JFrame posframe = new JFrame("Position");
		posframe.setContentPane(new ChartPanel(posChart));
		posframe.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		posframe.setLocation(772, 240);
		posframe.pack();
		posframe.setVisible(true);

	}

	public void setGoalPos(double[] goalPos) {
		this.goalPos=goalPos;

		startDistance1 = Math.sqrt(Math.pow(goalPos[0]-gps.getValues()[0],2) + Math.pow(goalPos[2]-gps.getValues()[2],2));
		startDistance[1]=goalPos[1]-0.0133333;
	}
	
	public void setTheta(double theta){
		this.theta=theta;
	}
	
	public void setNeedA(double needA){
		this.needA=needA;
	}
	
	public void setNeedB(int needB) {
		this.needB = needB;
	}
	
	public void setNeedABMuscles(){
		for(int i = 0; i<allMuscles.length;i++){
			allMuscles[i].setNeedA(needA);
			allMuscles[i].setNeedB(needB);
		}
	}
	
	//**MAIN METHOD **//
	public static void main(String[] args) {
		MyForceC controller = new MyForceC();
		GUI frame = new GUI(controller);       
		controller.run();
	}


}