
public class SensoryNeuron extends Neuron {
	private static final long serialVersionUID = 3494153218227798927L;
	private double sensorValue, v;
	private int lastUpDateTime;
	private double activationlvl=10;

	public SensoryNeuron(int id, double activationLvl,
			Layer parentLayer, Settings z) {
		super(id, activationLvl, parentLayer, z);
		sensorValue = 0;
	}

	public void setSensoryValue(double val) {
		sensorValue = val;
		lastUpDateTime=SpikingNetwork.currentTime;
	}

	public void checkFire() {
		if(z.getRandomInput()){
			sensorValue=Math.random();
			// FOR SINGEL NEURON TESTING ====================
			//			if(SpikingNetwork.currentTime==10|| SpikingNetwork.currentTime==25 || SpikingNetwork.currentTime==30){
			//				sensorValue=10000;
			//			}else{
			//				sensorValue=0;
			//			}

			double low = Math.random()/4;
			double high = Math.random()*4;

			//FOR TESTING THE LEARNING RULES
			if(name.equals("Neuron 9.0")){
				if(SpikingNetwork.currentTime<5000){
					sensorValue=high;	
				}else if(SpikingNetwork.currentTime<12000){
					sensorValue=low;
				}else if (SpikingNetwork.currentTime<15000){
					sensorValue=high;
				}else if (SpikingNetwork.currentTime<35000){
					sensorValue = low;
				}else if (SpikingNetwork.currentTime<18000){
					sensorValue =low;
				}else if (SpikingNetwork.currentTime<25000){
					sensorValue =high;
				}else if (SpikingNetwork.currentTime<31000){
					sensorValue =low;
				}else if (SpikingNetwork.currentTime<32500){
					sensorValue = low;
				}else{
					sensorValue=high;
				}
			}
			else if(name.equals("Neuron 7.0")){
				if(SpikingNetwork.currentTime<4000){
					sensorValue=low; //0.3+ SpikingNetwork.currentTime/1000.0;	
				}else if(SpikingNetwork.currentTime<113800){
					sensorValue=high;
				}else if (SpikingNetwork.currentTime<25000){
					sensorValue = high;
				}else if (SpikingNetwork.currentTime<30000){
					sensorValue =low;
				}else if (SpikingNetwork.currentTime<35000){
					sensorValue =high;
				}else if (SpikingNetwork.currentTime<36000){
					sensorValue =low;
				}else{
					sensorValue = high;
				}	
			}
			//		=============================================================		


			//SYNC WEBOTS AND ANN
		}else{
			//make sure that the sensory value is updated by webots atleast once pr weight update	
			while(SpikingNetwork.currentTime-lastUpDateTime>z.getWeightUpdateRate()){
				//				System.out.println("Waiting... "+ SpikingNetwork.currentTime);
				try {
					Thread.sleep(1);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}

		firingHistory = firingHistory << 1;
		v += sensorValue;
		if(spikeRateType==SPLIT_WINDOW){
			spikeHistoryIndex++;
			if(spikeHistoryIndex==spikeHistory.length){
				spikeHistoryIndex=0;
			}
			oldestValue=spikeHistory[spikeHistoryIndex];	//store oldes value before it is replaced
			spikeHistory[spikeHistoryIndex]=0;				//changed to 1 if fire
		}

		spikeRate= spikeRateAlfa*spikeRate ;	//slowly decrease the spikerate

		if (v > activationlvl) {
			spikeRate+= (1-spikeRateAlfa);		//increase the spikerate if spike
			if(spikeRateType==SPLIT_WINDOW){
				spikeHistory[spikeHistoryIndex]=1;
			}
			v = 0;
			for(int i=0; i<postSyn.size();i++) {
				postSyn.get(i).setPreNodeFired();
			}
			fired.add((double)SpikingNetwork.currentTime);
			parentLayer.addFiredToPlot(this);

			firingHistory += 1; 
			spikeDistance = SpikingNetwork.currentTime-lastFiredTime;
			lastFiredTime = SpikingNetwork.currentTime;
		}
		if(spikeRateType==SPLIT_WINDOW){
			updateCurrentSpikeRateWindow();
			updateOldSpikeRateWindow();
			updateCurrentPostNeuronSpikeRate();
			updateOldPostNeuronSpikeRate();		
		}
	}

}
