import org.LiveGraph.LiveGraph;



public class SkinnerSynapse extends Synapse{
	private static final long serialVersionUID = 1L;

	//Plotting stuff ------------------------------
	int startTime = 0;
	private String preNodeS ="Neuron 6.0";
	private String postNodeS = "Neuron 4.0";
	private double[] synWeight; 
	private double[] synTrace; 
	private double[] synPreSpi; 
	private double[] synPostSpi; 
	private double[] synDeltaPreSR; 
	private double[] currentTime; 
	private boolean notShown =false;
	private int counterPlot=0;
	// --------------------------------------------
	private String synTypePlot;
	private int lenghtOfEvent; 
	private int lastEventCounterPost=0;
	private boolean updateWeight=true;
	private double previousDropPre;
	private double minChange;
	private int lastEventPre=0;
	private int lastEventPost=0;
	private int lastEventCounterPre;
	private boolean useEvents;
	private double previousIncPost=0;
	private double previousDropPost=0;

	public SkinnerSynapse(Neuron preNode, Neuron postNode, int synType, double Asyn,
			Settings z, double initWeight) {
		super(preNode, postNode, synType, Asyn, z, initWeight);

		minChange=z.getMinChangeEvent();
		useEvents=z.getUseEvents();
		lenghtOfEvent= 2000/z.getWeightUpdateRate();

		if(preNode.name.equals(preNodeS) && postNode.name.equals(postNodeS)){
			synWeight = new double[durationOfPlot];
			synTrace = new double[durationOfPlot];
			synPreSpi = new double[durationOfPlot];
			synPostSpi = new double[durationOfPlot];
			synDeltaPreSR = new double[durationOfPlot];
			currentTime = new double[durationOfPlot];
		}
		prevTracePreSpikeRate = 0;

		if(synapseTypeInt==1){	
			synapseType = "S+";		//exitatory	
		}else if(synapseTypeInt==-1){	
			synapseType = "S-";		//inhibitory
		}else if(synapseTypeInt==0){
			synapseType = "S";		//can be both 	
		}else{
			System.err.println("Unknown synapsetype");
		}
		synTypePlot = "Skinner";	
	}

	public void updateWeight() {
		double deltaPreSpikeRate=0;
		double deltaPostSpikeRate=0;
		double deltaW=0;
		double tracePostSpikeRate=0;
		
		if(z.getSpikeRateType()==Globals.SPLIT_WINDOW){ 
			prevSpikeRate = preNode.getOldRealSpikeRateWindow();
			currentSpikeRate = preNode.getCurrentRealSpikeRateWindow();

			prevPostNeuronSpikerate = postNode.getOldSpikeRateWindow();//
			currentPostNeuronSpikerate = postNode.getCurrentSpikeRateWindow();

			deltaPreSpikeRate=  (currentSpikeRate-prevSpikeRate);	
			deltaPostSpikeRate =(currentPostNeuronSpikerate-prevPostNeuronSpikerate);

			//			for plotting use latest spikerate
			currentPostNeuronSpikerate=postNode.getCurrentRealSpikeRateWindow();
			if(SpikingNetwork.currentTime>z.getStartUpdateWeights()){
				deltaW= learningConstant* (-Math.min(deltaPreSpikeRate, 0)) * deltaPostSpikeRate;
			}
		}else{
			// Setting the previous spikerate, and updating the current one.
			prevSpikeRate = currentSpikeRate;
			currentSpikeRate = preNode.getSpikerate(delay);
			deltaPreNeuronSpikeRate= (currentSpikeRate-prevSpikeRate)/z.getWeightUpdateRate();
			prevPostNeuronSpikerate = currentPostNeuronSpikerate;
			currentPostNeuronSpikerate = postNode.getSpikerate(0);
			deltaPostNeuronSpikeRate = (currentPostNeuronSpikerate-prevPostNeuronSpikerate)/z.getWeightUpdateRate();

			// SKINNER learning rule.
			deltaPreSpikeRate = Math.pow(deltaPreNeuronSpikeRate, betta); 						// delta X
			deltaPostSpikeRate = Math.pow(deltaPostNeuronSpikeRate, betta); 	// delta Y

//			if(useEvents){
//				if(deltaPostSpikeRate>minChange && deltaPostSpikeRate>previousIncPost){
//					previousIncPost=deltaPostSpikeRate;
//					previousDropPost=0;
//					lastEventPost=SpikingNetwork.currentTime;
//					lastEventCounterPost= lenghtOfEvent;
//					//trace is active
//					//				System.out.println("Event post: " +lastEventPost);
//				}else if(deltaPostSpikeRate<-minChange && deltaPostSpikeRate<previousDropPost){
//					previousDropPost=deltaPostSpikeRate;
//					previousIncPost=0;
//					lastEventPost=SpikingNetwork.currentTime;
//					lastEventCounterPost= lenghtOfEvent;
//					//trace is active
//					//				System.out.println("Drop Event post: " +lastEventPost);
//				}
//				else if(lastEventCounterPost<1){
//					lastEventPost=-1;
//					previousIncPost=0;
//					previousDropPost=0;
//
//				}
//				if(deltaPreSpikeRate<-minChange && deltaPreSpikeRate<previousDropPre){//lastEventCounter<1){
//					previousDropPre=deltaPreSpikeRate;
//					lastEventPre=SpikingNetwork.currentTime;
//					//			lastEventCounter = lenghtOfTrace;
//					//				System.out.println("Event pre: " +lastEventPre);
//					//				updateWeight=true;					//trace is active
//					//				if(lastEventCounterPost<1){
//					//					updateWeight=false;			//do not update weight
//					//				}
//					lastEventCounterPre = lenghtOfEvent;
//				}
//				lastEventCounterPost--;
//				lastEventCounterPre--;
//				if(lastEventCounterPre<1){
//					previousDropPre=0;
//					lastEventPre=-1;
//				}
//				if(lastEventPost>=lastEventPre ){// || lastEventPost==-1 --> weight stop update 2000 ms after post, without-> weight will update as 2000 after pre or the trace of post dies
//					updateWeight=false;
//				}else{
//					updateWeight=true;	
//				}
//			}	
			
			tracePostSpikeRate = prevTracePostSpikeRate;			
			if(z.getStartUpdateWeights()>SpikingNetwork.currentTime || !updateWeight){
				deltaW=0;	//wont update the weight in the start phase.. 
			}else{
				//WEIGHT UPDATE RULE
				deltaW = learningConstant* (   (-Math.min(deltaPreSpikeRate, 0)) * tracePostSpikeRate 
						- Math.abs(tracePostSpikeRate)*currentWeight*z.getForgettingConstant()); 
				//every time spikerate changes in the post neuron the weight is drawn a little towards 0,.. 
				//unless the spikerate in the pre nuron during the trace, decreases, then the weight increase/decrease much, 
			}
			prevTracePostSpikeRate = alfa * prevTracePostSpikeRate + (1-alfa)* deltaPostSpikeRate;	
		}
		currentWeight += deltaW;

		if(synapseTypeInt==1){	
			if(currentWeight<0) currentWeight = 0;		//exitatory	cannot have negative weight	
		}else if(synapseTypeInt==-1){	
			if(currentWeight>0) currentWeight = 0;		//inhibitory cannot have positive weight	
		}else if(synapseTypeInt==0){
			//can be both negative and positive
		}else{
			System.err.println("Unknown synapsetype");
		}

		//TEST PLOTTING 

		if(preNode.name.equals(preNodeS) && postNode.name.equals(postNodeS)){
			if(counterPlot<synWeight.length && SpikingNetwork.currentTime>startTime ){
				synWeight[counterPlot]= currentWeight;
				synPreSpi[counterPlot]= currentSpikeRate;
				synPostSpi[counterPlot]= currentPostNeuronSpikerate;
				synDeltaPreSR[counterPlot] = deltaPreSpikeRate;
				currentTime[counterPlot] = SpikingNetwork.currentTime;
				if(z.getSpikeRateType()==Globals.SPLIT_WINDOW){
					synTrace[counterPlot]= deltaPostSpikeRate;
				}else{
					synTrace[counterPlot]= tracePostSpikeRate;
				}
				counterPlot++;
				notShown=true;
			}else if(notShown){
				notShown =false;
				if(z.getSpikeRateType()==Globals.SPLIT_WINDOW){
					showGraph(currentTime,synWeight,synTrace,"deltaPostNodeSpikeRate",synPreSpi,synPostSpi, synDeltaPreSR, "deltaPreSpikeRate", preNodeS, postNodeS, synTypePlot);
				}else{
					showGraph(currentTime,synWeight,synTrace,"tracePostNode",synPreSpi,synPostSpi, synDeltaPreSR, "deltaPreSpikeRate", preNodeS, postNodeS, synTypePlot);
				}
			}
		}
	}
}
